Package ec.select

# Class TournamentSelection

java.lang.Object
ec.BreedingSource
ec.SelectionMethod
ec.select.TournamentSelection

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

Direct Known Subclasses:
  `LexicographicTournamentSelection`, `ProportionalTournamentSelection`, `SpatialTournamentSelection`

public class TournamentSelection extends SelectionMethod implements SteadyStateBSourceForm
Does a simple tournament selection, limited to the subpopulation it's working in at the time.

Tournament selection works like this: first, size individuals are chosen at random from the population. Then of those individuals, the one with the best fitness is selected.

size can be any floating point value >= 1.0. If it is a non- integer value x then either a tournament of size ceil(x) is used (with probability x - floor(x)), else a tournament of size floor(x) is used.

Common sizes for size include: 2, popular in Genetic Algorithms circles, and 7, popularized in Genetic Programming by John Koza. If the size is 1, then individuals are picked entirely at random.

Tournament selection is so simple that it doesn't need to maintain a cache of any form, so many of the SelectionMethod methods just don't do anything at all.

Typical Number of Individuals Produced Per `produce(...)` call
Always 1.

Parameters

base.`size` double >= 1 | (the tournament size)
base.`pick-worst` bool = `true` or `false` (default) | (should we pick the worst individual in the tournament instead of the best?)

Default Base
select.tournament

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `P_PICKWORST`
  `static final String`
  `P_SIZE`
  size parameter
  `static final String`
  `P_TOURNAMENT`
  default base
  `boolean`
  `pickWorst`
  Do we pick the worst instead of the best?
  `double`
  `probabilityOfPickingSizePlusOne`
  Probablity of picking the size plus one
  `int`
  `size`
  Base size of the tournament; this may change.

  ### Fields inherited from class ec.SelectionMethod

  `INDS_PRODUCED, KEY_PARENTS`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TournamentSelection()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `betterThan(Individual first, Individual second, int subpopulation, EvolutionState state, int thread)`
  Returns true if *first* is a better (fitter, whatever) individual than *second*.
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `getRandomIndividual(int number, int subpopulation, EvolutionState state, int thread)`
  Produces the index of a (typically uniformly distributed) randomly chosen individual to fill the tournament.
  `int`
  `getTournamentSizeToUse(MersenneTwisterFast random)`
  Returns a tournament size to use, at random, based on base size and probability of picking the size plus one.
  `void`
  `individualReplaced(SteadyStateEvolutionState state, int subpopulation, int thread, int individual)`
  Called whenever an individual has been replaced by another in the population.
  `int`
  `produce(int subpopulation, EvolutionState state, int thread)`
  An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `void`
  `sourcesAreProperForm(SteadyStateEvolutionState state)`
  Issue an error (not a fatal -- we guarantee that callers of this method will also call exitIfErrors) if any of your sources, or their sources, etc., are not of SteadyStateBSourceForm.

  ### Methods inherited from class ec.SelectionMethod

  `finishProducing, prepareToProduce, produce, produces, produceWithoutCloning, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `clone, fillStubs, getProbability, pickRandom, preparePipeline, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_TOURNAMENT

    public static final String P_TOURNAMENT
    default base
    See Also:
      - Constant Field Values

  - ### P_PICKWORST

    public static final String P_PICKWORST
    See Also:
      - Constant Field Values

  - ### P_SIZE

    public static final String P_SIZE
    size parameter
    See Also:
      - Constant Field Values

  - ### size

    public int size
    Base size of the tournament; this may change.

  - ### probabilityOfPickingSizePlusOne

    public double probabilityOfPickingSizePlusOne
    Probablity of picking the size plus one

  - ### pickWorst

    public boolean pickWorst
    Do we pick the worst instead of the best?

- ## Constructor Details

  - ### TournamentSelection

    public TournamentSelection()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingSource`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### getTournamentSizeToUse

    public int getTournamentSizeToUse(MersenneTwisterFast random)
    Returns a tournament size to use, at random, based on base size and probability of picking the size plus one.

  - ### getRandomIndividual

    public int getRandomIndividual(int number, int subpopulation, EvolutionState state, int thread)
    Produces the index of a (typically uniformly distributed) randomly chosen individual to fill the tournament. numberinvalid input: '<'/> is the position of the individual in the tournament.

  - ### betterThan

    public boolean betterThan(Individual first, Individual second, int subpopulation, EvolutionState state, int thread)
    Returns true if *first* is a better (fitter, whatever) individual than *second*.

  - ### produce

    public int produce(int subpopulation, EvolutionState state, int thread)
    Description copied from class: `SelectionMethod`
    An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
    Specified by:
      `produce` in class `SelectionMethod`

  - ### individualReplaced

    public void individualReplaced(SteadyStateEvolutionState state, int subpopulation, int thread, int individual)
    Description copied from interface: `SteadyStateBSourceForm`
    Called whenever an individual has been replaced by another in the population.
    Specified by:
      `individualReplaced` in interface `SteadyStateBSourceForm`

  - ### sourcesAreProperForm

    public void sourcesAreProperForm(SteadyStateEvolutionState state)
    Description copied from interface: `SteadyStateBSourceForm`
    Issue an error (not a fatal -- we guarantee that callers of this method will also call exitIfErrors) if any of your sources, or their sources, etc., are not of SteadyStateBSourceForm.
    Specified by:
      `sourcesAreProperForm` in interface `SteadyStateBSourceForm`